module Bamboo.Theme.MiniHTML5 where

import Bamboo.Type.ThemeInterface
import Bamboo.Theme.MiniHTML5.Env hiding (Search)
import Prelude ()

import qualified Bamboo.Theme.MiniHTML5.Control.Post as PostV
import qualified Bamboo.Theme.MiniHTML5.Control.Search as SearchV
import qualified Bamboo.Theme.MiniHTML5.Control.Static as StaticV
import qualified Bamboo.Theme.MiniHTML5.Widget.RSS as RSSV
import qualified Bamboo.Theme.MiniHTML5.Control.Tag as TagV
import qualified Bamboo.Type.State as S

theme :: Theme
theme x' y = theme' x' y  .return
  where
    theme' Index x      = PostV.list x
    theme' Search x     = SearchV.view x
    theme' Static x     = StaticV.view x
    theme' Post x       = PostV.view x
    theme' Tag x        = TagV.view x

    theme' IndexFeed x  = RSSV.rss x "" "" .render_rss .rss_response
    theme' TagFeed x    = RSSV.rss x (x.config.tag_id) (x.S.tag_name) .render_rss .rss_response



